Index: trunk/source/Lib/TLibRenderer/TRenFilter.cpp
===================================================================
--- trunk/source/Lib/TLibRenderer/TRenFilter.cpp	(revision 296)
+++ trunk/source/Lib/TLibRenderer/TRenFilter.cpp	(revision 608)
@@ -36,5 +36,5 @@
 #include "TRenFilter.h"
 #include "TRenInterpFilter.h"
-
+#if H_3D
 
 ///// COMMON /////
@@ -72,5 +72,5 @@
   }
   // Set Threshold
-  riBlendZThres  = ( Max( abs(piInvZLUTLeft[0]- piInvZLUTLeft[255]), abs(piInvZLUTRight[0]- piInvZLUTRight[255]) ) * iBlendZThresPerc + 50)  / 100;
+  riBlendZThres  = ( std::max( abs(piInvZLUTLeft[0]- piInvZLUTLeft[255]), abs(piInvZLUTRight[0]- piInvZLUTRight[255]) ) * iBlendZThresPerc + 50)  / 100;
 }
 
@@ -194,5 +194,5 @@
 
 /////////// Comparison ///////////
-Int64 TRenFilter::SSE   (PelImagePlane* pcInputPlane1, PelImagePlane* pcInputPlane2   )
+Int64 TRenFilter::SSE   (PelImagePlane* pcInputPlane1, PelImagePlane* pcInputPlane2, Bool bLuma )
 {
   UInt uiWidth     = pcInputPlane1->getWidth();
@@ -205,12 +205,13 @@
   Pel* pucImData2  = pcInputPlane2->getPlaneData();
 
-  return SSE( pucImData1, (Int) uiStride1, (Int) uiWidth, (Int) uiHeight, pucImData2, (Int) uiStride2 );
-}
-
-Int64 TRenFilter::SSE( Pel* piSrc1, Int iSrcStride1, Int iWidth, Int iHeight,  Pel* piSrc2, Int iSrcStride2 )
+  return SSE( pucImData1, (Int) uiStride1, (Int) uiWidth, (Int) uiHeight, pucImData2, (Int) uiStride2, bLuma );
+}
+
+Int64 TRenFilter::SSE( Pel* piSrc1, Int iSrcStride1, Int iWidth, Int iHeight,  Pel* piSrc2, Int iSrcStride2, Bool bLuma )
 {
   Int64 iSSE = 0;
 
-  Int iShift = g_uiBitIncrement << 1;
+
+  Int iShift = DISTORTION_PRECISION_ADJUSTMENT( ( bLuma ? g_bitDepthY : g_bitDepthC ) - 8 ) << 1 ;
   for(Int iPosY = 0; iPosY < iHeight; iPosY++)
   {
@@ -266,5 +267,7 @@
 
 inline Void TRenFilter::sampleUp2Tap13(PelImage* pcInputImage, PelImage* pcOutputImage)
-{// UpSampling from JSVM Software (DownConvertStatic) ???
+{ // UpSampling from JSVM Software (DownConvertStatic) ???
+
+  AOF( g_bitDepthC == g_bitDepthY ); 
   UInt uiNumPlanes = pcInputImage->getNumberOfPlanes();
 
@@ -397,5 +400,5 @@
       {
         // Scale and copy to image buffer.
-        pcOutputPlaneData[iOffset+i] = Max(Min((Pel) ((piDst[i] + iAddH) / iDivH), g_uiBASE_MAX ),0);
+        pcOutputPlaneData[iOffset+i] = ClipY((Pel) ((piDst[i] + iAddH) / iDivH));
       }
     }
@@ -421,4 +424,7 @@
 Void TRenFilter::sampleDown2Tap13( Pel* pcInputPlaneData, Int iInputStride, Int iWidth, Int iHeight, Pel* pcOutputPlaneData, Int iOutputStride  )
 { // DownSampling from JSVM Software (DownConvertStatic) ??
+  
+  AOF( g_bitDepthC == g_bitDepthY ); 
+
   Int iOffset, iPosX, iPosY, k;
   Int* piDataHorDown = new Int[(Int)(iWidth * iHeight / 2)];
@@ -543,5 +549,5 @@
     {
       // Scale and copy back to image buffer.
-      pcOutputPlaneData[iOutputStride*iPosY+iPosX] = Max(Min( ( Pel) ( (piDst[iPosY] + iAddV) / iDivV), g_uiBASE_MAX ),0);
+      pcOutputPlaneData[iOutputStride*iPosY+iPosX] = ClipY( ( Pel) ( (piDst[iPosY] + iAddV) / iDivV));
     }
   }
@@ -569,5 +575,7 @@
 
 Void TRenFilter::sampleVerDown2Tap13( PelImagePlane* pcInputPlane, PelImagePlane* pcOutputPlane, Int uiPad)
-{ // DownSampling from JSVM Software (DownConvertStatic) ??
+{ 
+  assert( g_bitDepthY == g_bitDepthC); // ToDo: Update renderer to work with different luma/chroma bit depth 
+  // DownSampling from JSVM Software (DownConvertStatic) ??
   Int iWidth       = pcInputPlane->getWidth();
   Int iHeight      = pcInputPlane->getHeight();
@@ -614,5 +622,5 @@
 
       Int iSum = iTmp4 + iTmp3 - iTmp2 + ((iTmp0 + iTmp4 + iTmp5 - iTmp2) << 1) + ( ( iTmp3 - iTmp1)  << 2) + (  iTmp5 << 3 ) + (( iTmp4 + iTmp5 ) << 4);
-      pcOutputPlaneData[ iXPos ] = (Pel) Clip((iSum + 32) >> 6);
+      pcOutputPlaneData[ iXPos ] = (Pel) ClipY((iSum + 32) >> 6);
       pcTmpIn++;
     }
@@ -623,5 +631,7 @@
 
 Void TRenFilter::sampleHorDown2Tap13( PelImagePlane* pcInputPlane, PelImagePlane* pcOutputPlane, Int uiPad )
-{ // DownSampling from JSVM Software (DownConvertStatic) ??
+{ 
+  assert( g_bitDepthY == g_bitDepthC); // ToDo: Update renderer to work with different luma/chroma bit depth 
+  // DownSampling from JSVM Software (DownConvertStatic) ??
   Int iWidth       = pcInputPlane->getWidth();
   Int iHeight      = pcInputPlane->getHeight();
@@ -653,5 +663,5 @@
 
       Int iSum = iTmp4 + iTmp3 - iTmp2 + ((iTmp0 + iTmp4 + iTmp5 - iTmp2) << 1) + ( ( iTmp3 - iTmp1)  << 2) + (  iTmp5 << 3 ) + (( iTmp4 + iTmp5 ) << 4);
-      pcOutputPlaneData[ iXPos ] = (Pel) Clip((iSum + 32) >> 6);
+      pcOutputPlaneData[ iXPos ] = (Pel) ClipY((iSum + 32) >> 6);
       pcTmpIn += 2;
     }
@@ -810,10 +820,13 @@
 Pel TRenFilter::xFiltBinom3( Pel* pcInputData, Int iStride )
 {
+  assert( g_bitDepthY == g_bitDepthC); // ToDo: Update renderer to work with different luma/chroma bit depth 
+
   Int iSum = pcInputData[-1 * iStride ] + pcInputData[ 0 ] +  (pcInputData[iStride ] << 1 );
-  return Clip( (iSum +  2) >>  2 );
+  return ClipY( (iSum +  2) >>  2 );
 }
 
 Pel TRenFilter::xFiltBinom5( Pel* pcInputData, Int iStride )
 {
+  assert( g_bitDepthY == g_bitDepthC); // ToDo: Update renderer to work with different luma/chroma bit depth 
   // { 1,4,6,4,1 }
   Int iStride0  = 0;
@@ -828,9 +841,10 @@
 
   Int iSum = iTmp0 +  (iTmp2 << 1) + ((iTmp1 + iTmp2) << 2);
-  return Clip( (iSum +  8) >>  4 );
+  return ClipY( (iSum +  8) >>  4 );
 }
 
 Pel TRenFilter::xFiltBinom7( Pel* pcInputData, Int iStride )
 {
+  assert( g_bitDepthY == g_bitDepthC); // ToDo: Update renderer to work with different luma/chroma bit depth 
   // { 1,6,15,20,15,6,1 }
   Int iStride0  = 0;
@@ -849,9 +863,10 @@
   Int iSum = iTmp0 - iTmp2 + ( iTmp1  << 1) + ( (iTmp1 + iTmp3) << 2) + ((iTmp2 + iTmp3) << 4);
 
-  return Clip( (iSum +  32) >>  6 );
+  return ClipY( (iSum +  32) >>  6 );
 }
 
 Pel TRenFilter::xFiltBinom9( Pel* pcInputData, Int iStride )
 {
+  assert( g_bitDepthY == g_bitDepthC); // ToDo: Update renderer to work with different luma/chroma bit depth 
   // {  1     8    28    56    70    56    28     8     1 }
   Int iStride0  = 0;
@@ -873,5 +888,5 @@
   Int iSum = iTmp0 + ((iTmp4 ) << 1) + ( ( iTmp4 - iTmp2 ) << 2) +  ( (iTmp1 - iTmp3) << 3 ) +  ((iTmp2 ) << 5) + ((iTmp3+ iTmp4 ) << 6);
 
-  return Clip( (iSum +  128) >>  8 );
+  return ClipY( (iSum +  128) >>  8 );
 }
 
@@ -1226,4 +1241,5 @@
 Void TRenFilter::xInterpHorChroma( Pel* piSrc, Int iSrcStride, Int iSrcStepX, Int iSrcStepY, Int iWidth, Int iHeight, Pel* piDst, Int iDstStride, Int iDstStepX, Int iDstStepY, FpChromaIntFilt fpFilter )
 {
+  assert( g_bitDepthY == g_bitDepthC); // ToDo: Update renderer to work with different luma/chroma bit depth 
   Int   iSum;
   Pel*  piSrcTmp;
@@ -1236,5 +1252,5 @@
     {
       iSum      = (cFilter.*fpFilter)( piSrcTmp,  iSrcStepX );
-      piDst[x * iDstStepX ] =  Clip ((iSum +  32) >>  6 );
+      piDst[x * iDstStepX ] =  ClipC ((iSum +  32) >>  6 );
       piSrcTmp+= iSrcStepX;
     }
@@ -1246,4 +1262,5 @@
 Void TRenFilter::xInterpVerChroma( Pel* piSrc, Int iSrcStride, Int iSrcStepX, Int iSrcStepY, Int iWidth, Int iHeight, Pel* piDst, Int iDstStride, Int iDstStepX, Int iDstStepY, FpChromaIntFilt fpFilter )
 {
+  assert( g_bitDepthY == g_bitDepthC); // ToDo: Update renderer to work with different luma/chroma bit depth 
   Int   iSum;
   Pel*  piSrcTmp;
@@ -1256,5 +1273,5 @@
     {
       iSum      = (cFilter.*fpFilter)( piSrcTmp,  iSrcStepY * iSrcStride );
-      piDst[x * iDstStepX ]  =  Clip ((iSum +  32) >>  6 );
+      piDst[x * iDstStepX ]  =  ClipC ((iSum +  32) >>  6 );
       piSrcTmp += iSrcStepX;
     }
@@ -1267,4 +1284,7 @@
 Void TRenFilter::xSampleDownHor2( Pel* piSrc, Int iSrcStride, Int iSrcWidth, Int iHeight, Pel* piDst, Int iDstStride  )
 {
+  
+  assert( g_bitDepthY == g_bitDepthC); // ToDo: Update renderer to work with different luma/chroma bit depth 
+
   Int   iSum;
   Pel*  piSrcTmp;
@@ -1278,5 +1298,5 @@
       // { 1,2,1 }
       iSum = piSrcTmp[0] + piSrcTmp[2] +  (piSrcTmp[1] << 1);
-      piDst[x] = Clip( (iSum +  2) >>  2 );
+      piDst[x] = ClipY( (iSum +  2) >>  2 );
       piSrcTmp += 2;
     }
@@ -1288,4 +1308,6 @@
 Void TRenFilter::xSampleDownVer2( Pel* piSrc, Int iSrcStride, Int iSrcWidth, Int iSrcHeight, Pel* piDst, Int iDstStride  )
 {
+  assert( g_bitDepthY == g_bitDepthC); // ToDo: Update renderer to work with different luma/chroma bit depth 
+
   Int   iSum;
   Pel*  piSrcTmp;
@@ -1298,5 +1320,5 @@
       // { 1,2,1 }
       iSum = piSrcTmp[0] + piSrcTmp[ iSrcStride << 1] +  (piSrcTmp[ iSrcStride ] << 1);
-      piDst[x] = Clip( (iSum +  2) >>  2 );
+      piDst[x] = ClipY( (iSum +  2) >>  2 );
       piSrcTmp += 1;
     }
@@ -1308,4 +1330,6 @@
 Void TRenFilter::xSampleDownHor4( Pel* piSrc, Int iSrcStride, Int iSrcWidth, Int iHeight, Pel* piDst, Int iDstStride  )
 {
+  assert( g_bitDepthY == g_bitDepthC); // ToDo: Update renderer to work with different luma/chroma bit depth 
+
   Int   iSum;
   Pel*  piSrcTmp;
@@ -1324,5 +1348,5 @@
 
       iSum = iTmp0 +  (iTmp2 << 1) + ((iTmp1 + iTmp2) << 2);
-      piDst[x] = Clip( (iSum +  8) >>  4 );
+      piDst[x] = ClipY( (iSum +  8) >>  4 );
       piSrcTmp += 4;
     }
@@ -1334,4 +1358,6 @@
 Void TRenFilter::xSampleDownHor8( Pel* piSrc, Int iSrcStride, Int iSrcWidth, Int iHeight, Pel* piDst, Int iDstStride  )
 {
+  assert( g_bitDepthY == g_bitDepthC); // ToDo: Update renderer to work with different luma/chroma bit depth 
+
   Int   iSum;
   Pel*  piSrcTmp;
@@ -1351,5 +1377,5 @@
 
       iSum = iTmp0 - iTmp2 + ( iTmp1  << 1) + ( (iTmp1 + iTmp3) << 2) + ((iTmp2 + iTmp3) << 4);
-      piDst[x] = Clip( (iSum +  32) >>  6 );
+      piDst[x] = ClipY( (iSum +  32) >>  6 );
       piSrcTmp += 8;
     }
@@ -1433,2 +1459,5 @@
 template Void TRenFilter::mirrorHor(        TRenImage<Int>           *pcImage );
 template Void TRenFilter::mirrorHor(        TRenImagePlane<Pel>      *pcImagePlane );
+
+#endif 
+
Index: trunk/source/Lib/TLibRenderer/TRenFilter.h
===================================================================
--- trunk/source/Lib/TLibRenderer/TRenFilter.h	(revision 296)
+++ trunk/source/Lib/TLibRenderer/TRenFilter.h	(revision 608)
@@ -33,5 +33,4 @@
 
 
-
 #ifndef __TRENFILTER__
 #define __TRENFILTER__
@@ -40,4 +39,5 @@
 #include "TRenImage.h"
 #include "TRenInterpFilter.h"
+#if H_3D
 
 typedef Int (TRenInterpFilter::*FpChromaIntFilt) ( Pel*, Int );
@@ -62,6 +62,6 @@
   /////////// Comparison ///////////
 
-  static Int64                          SSE  ( PelImagePlane*     pcInputPlane1, PelImagePlane*      pcInputPlane2 );
-  static Int64                          SSE  ( Pel* piSrc1,       Int iSrcStride1, Int iWidth, Int iHeight,  Pel* piSrc2, Int iSrcStride2 );
+  static Int64                          SSE  ( PelImagePlane*     pcInputPlane1, PelImagePlane*      pcInputPlane2, Bool bLuma );
+  static Int64                          SSE  ( Pel* piSrc1,       Int iSrcStride1, Int iWidth, Int iHeight,  Pel* piSrc2, Int iSrcStride2, Bool bLuma );
 
   template <typename T> static Bool compare  (TRenImage<T> *pcInputImage1     , TRenImage<T> *pcInputImage2);
@@ -138,4 +138,4 @@
 };
 
-
+#endif
 #endif //__TRENFILTER__
Index: trunk/source/Lib/TLibRenderer/TRenImage.cpp
===================================================================
--- trunk/source/Lib/TLibRenderer/TRenImage.cpp	(revision 296)
+++ trunk/source/Lib/TLibRenderer/TRenImage.cpp	(revision 608)
@@ -37,4 +37,6 @@
 #include "TRenFilter.h"
 #include "assert.h"
+#if H_3D
+
 
 template<typename T>
@@ -231,5 +233,5 @@
   for (UInt uiCurPlane = 1; uiCurPlane < m_uiNumberOfPlanes; uiCurPlane++)
   {
-    m_apcPlanes[uiCurPlane]->assign( (Pel) ((g_uiIBDI_MAX+1) >> 1) );
+    m_apcPlanes[uiCurPlane]->assign( (Pel) ( 1 << ( g_bitDepthC - 1 ) ) );
   }
 }
@@ -270,2 +272,3 @@
 template Void TRenImage<Pel>::assign<Pel>    (TRenImage<Pel>*   );
 
+#endif // H_3D
Index: trunk/source/Lib/TLibRenderer/TRenImage.h
===================================================================
--- trunk/source/Lib/TLibRenderer/TRenImage.h	(revision 296)
+++ trunk/source/Lib/TLibRenderer/TRenImage.h	(revision 608)
@@ -39,4 +39,5 @@
 #include "../TLibCommon/TComPicYuv.h"
 #include "TRenImagePlane.h"
+#if H_3D
 
 
@@ -99,4 +100,5 @@
 };
 
+#endif // H_3D
 #endif // __TRENIMAGE__
 
Index: trunk/source/Lib/TLibRenderer/TRenImagePlane.cpp
===================================================================
--- trunk/source/Lib/TLibRenderer/TRenImagePlane.cpp	(revision 296)
+++ trunk/source/Lib/TLibRenderer/TRenImagePlane.cpp	(revision 608)
@@ -36,4 +36,6 @@
 #include "TRenFilter.h"
 #include <string.h>
+#if H_3D
+
 /////// TRenImagePlane ///////
 
@@ -526,2 +528,4 @@
 template class TRenImagePlanePart<Bool>;
 template class TRenImagePlanePart<Int>;
+#endif // H_3D
+
Index: trunk/source/Lib/TLibRenderer/TRenImagePlane.h
===================================================================
--- trunk/source/Lib/TLibRenderer/TRenImagePlane.h	(revision 296)
+++ trunk/source/Lib/TLibRenderer/TRenImagePlane.h	(revision 608)
@@ -39,4 +39,5 @@
 #include "../TLibCommon/TComPicYuv.h"
 
+#if H_3D
 #define PelImagePlane     TRenImagePlane<Pel>
 #define DoubleImagePlane  TRenImagePlane<Double>
@@ -121,3 +122,4 @@
 };
 
+#endif // H_3D
 #endif // __TRENIMAGEPLANE__
Index: trunk/source/Lib/TLibRenderer/TRenInterpFilter.cpp
===================================================================
--- trunk/source/Lib/TLibRenderer/TRenInterpFilter.cpp	(revision 296)
+++ trunk/source/Lib/TLibRenderer/TRenInterpFilter.cpp	(revision 608)
@@ -39,4 +39,5 @@
 
 #include "TRenInterpFilter.h"
+#if H_3D
 
 // ====================================================================================================================
@@ -49,2 +50,4 @@
 }
 
+#endif // H_3D
+
